
package tcpechoclient;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.Socket;
import java.net.SocketException;

public class TCPEchoClient {

    public static void main(String[] args) throws IOException
    {
     
        String serverIP = "192.168.0.19";
        int serverPort = 9999;
     
        //TCP client 소켓을 생성
        Socket socket = new Socket(serverIP, serverPort);
        System.out.println("Connected to server... sending echo string");
        
        InputStream in = socket.getInputStream();
        OutputStream out = socket.getOutputStream();
        
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String input;
        int dataLen;
        
        byte[] receivedData = new byte[100];
        
        for(;;) {
            //사용자로부터 문자열 입력--
            System.out.print("send:(x:종료) ");
            input = br.readLine();
            
            if(input.equals("x")) break;
            
            byte[] buff = input.getBytes();
            
            dataLen = buff.length;
            
            //서버로 메시지를 전송 ...
            out.write(buff);
            
            int totalBytesRcvd = 0;
            int bytesRead = 0;

            while(totalBytesRcvd < dataLen) 
            {
                bytesRead = in.read(receivedData, totalBytesRcvd,  dataLen - totalBytesRcvd);
                if( bytesRead == -1) {
                    throw new SocketException("연결이 예기치 않게 끊어졌습니다.");
                }
                totalBytesRcvd += bytesRead;
            }

            System.out.println("받은 메시지: " + new String(receivedData));
            
        }//for
        
        
        
        //소켓과 전송 채널을 닫기
        socket.close();
        
    }//main
    
}//calss
