package tcpechoserver;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketAddress;

public class TCPEchoServer {

    private static final int BUFSIZE = 32;
    
    public static void main(String[] args) throws IOException
    {
        
        if(args. length != 1)
        {
            throw new IllegalArgumentException("Parameter:  port");
        }
        
        int servPort = Integer.parseInt(args[0]);
        
        //서버 소켓을 생성 ---
        ServerSocket servSock = new ServerSocket(servPort);
        
        int recvMsgSize;
        byte[] receiveBuf = new byte[BUFSIZE];
        
        while(true) {
            //클라이언트의 연결요청을 받아들임.
            Socket clientSock = servSock.accept();
            
            SocketAddress clientAddress = clientSock.getRemoteSocketAddress();
            System.out.println("Client (" + clientAddress + ") connected...");
            
            InputStream in = clientSock.getInputStream();
            OutputStream out = clientSock.getOutputStream();
            
            //클라이언트로부터 오는 메시지를 받음 ---
            while ((recvMsgSize = in.read(receiveBuf)) != -1) {
                out.write(receiveBuf, 0, recvMsgSize); //받은 만큼 돌려주기..
            }
            
            clientSock.close();
        }//while
        
      
    }//main
    
}//classs
